/*
 * Automatically generated from dnsdata.rpc
 */

#ifndef _DNSDATA_RPC_
#define _DNSDATA_RPC_

#include <stdint.h>
#define EVTAG_HAS(msg, member) ((msg)->member##_set == 1)
#define EVTAG_ASSIGN(msg, member, args...) (*(msg)->base->member##_assign)(msg, ## args)
#define EVTAG_GET(msg, member, args...) (*(msg)->base->member##_get)(msg, ## args)
#define EVTAG_ADD(msg, member, args...) (*(msg)->base->member##_add)(msg, ## args)
#define EVTAG_LEN(msg, member) ((msg)->member##_length)

struct HTTPHeader;
struct HTTPServerReply;
struct DNSRequest;
struct DNSResponder;
struct StateGenerate;
struct Address;
struct State;

/* Tag definition for HTTPHeader */
enum httpheader_ {
  HTTPHEADER_KEY=1,
  HTTPHEADER_VALUE=2,
  HTTPHEADER_MAX_TAGS
};

/* Structure declaration for HTTPHeader */
struct HTTPHeader_access_ {
  int (*key_assign)(struct HTTPHeader *, const char *);
  int (*key_get)(struct HTTPHeader *, char * *);
  int (*value_assign)(struct HTTPHeader *, const char *);
  int (*value_get)(struct HTTPHeader *, char * *);
};

struct HTTPHeader {
  struct HTTPHeader_access_ *base;

  char *key_data;
  char *value_data;

  uint8_t key_set;
  uint8_t value_set;
};

struct HTTPHeader *HTTPHeader_new(void);
void HTTPHeader_free(struct HTTPHeader *);
void HTTPHeader_clear(struct HTTPHeader *);
void HTTPHeader_marshal(struct evbuffer *, const struct HTTPHeader *);
int HTTPHeader_unmarshal(struct HTTPHeader *, struct evbuffer *);
int HTTPHeader_complete(struct HTTPHeader *);
void evtag_marshal_HTTPHeader(struct evbuffer *, uint32_t, 
    const struct HTTPHeader *);
int evtag_unmarshal_HTTPHeader(struct evbuffer *, uint32_t,
    struct HTTPHeader *);
int HTTPHeader_key_assign(struct HTTPHeader *, const char *);
int HTTPHeader_key_get(struct HTTPHeader *, char * *);
int HTTPHeader_value_assign(struct HTTPHeader *, const char *);
int HTTPHeader_value_get(struct HTTPHeader *, char * *);
/* --- HTTPHeader done --- */

/* Tag definition for HTTPServerReply */
enum httpserverreply_ {
  HTTPSERVERREPLY_RESPONSE_CODE=1,
  HTTPSERVERREPLY_RESPONSE_STRING=2,
  HTTPSERVERREPLY_HEADERS=3,
  HTTPSERVERREPLY_BODY_CONTENT=4,
  HTTPSERVERREPLY_MAX_TAGS
};

/* Structure declaration for HTTPServerReply */
struct HTTPServerReply_access_ {
  int (*response_code_assign)(struct HTTPServerReply *, const uint32_t);
  int (*response_code_get)(struct HTTPServerReply *, uint32_t *);
  int (*response_string_assign)(struct HTTPServerReply *, const char *);
  int (*response_string_get)(struct HTTPServerReply *, char * *);
  int (*headers_assign)(struct HTTPServerReply *, int, const struct HTTPHeader*);
  int (*headers_get)(struct HTTPServerReply *, int, struct HTTPHeader* *);
  struct HTTPHeader*  (*headers_add)(struct HTTPServerReply *msg);
  int (*body_content_assign)(struct HTTPServerReply *, const uint8_t *, uint32_t);
  int (*body_content_get)(struct HTTPServerReply *, uint8_t * *, uint32_t *);
};

struct HTTPServerReply {
  struct HTTPServerReply_access_ *base;

  uint32_t response_code_data;
  char *response_string_data;
  struct HTTPHeader* *headers_data;
  int headers_length;
  int headers_num_allocated;
  uint8_t *body_content_data;
  uint32_t body_content_length;

  uint8_t response_code_set;
  uint8_t response_string_set;
  uint8_t headers_set;
  uint8_t body_content_set;
};

struct HTTPServerReply *HTTPServerReply_new(void);
void HTTPServerReply_free(struct HTTPServerReply *);
void HTTPServerReply_clear(struct HTTPServerReply *);
void HTTPServerReply_marshal(struct evbuffer *, const struct HTTPServerReply *);
int HTTPServerReply_unmarshal(struct HTTPServerReply *, struct evbuffer *);
int HTTPServerReply_complete(struct HTTPServerReply *);
void evtag_marshal_HTTPServerReply(struct evbuffer *, uint32_t, 
    const struct HTTPServerReply *);
int evtag_unmarshal_HTTPServerReply(struct evbuffer *, uint32_t,
    struct HTTPServerReply *);
int HTTPServerReply_response_code_assign(struct HTTPServerReply *, const uint32_t);
int HTTPServerReply_response_code_get(struct HTTPServerReply *, uint32_t *);
int HTTPServerReply_response_string_assign(struct HTTPServerReply *, const char *);
int HTTPServerReply_response_string_get(struct HTTPServerReply *, char * *);
int HTTPServerReply_headers_assign(struct HTTPServerReply *, int, const struct HTTPHeader*);
int HTTPServerReply_headers_get(struct HTTPServerReply *, int, struct HTTPHeader* *);
struct HTTPHeader*  HTTPServerReply_headers_add(struct HTTPServerReply *msg);
int HTTPServerReply_body_content_assign(struct HTTPServerReply *, const uint8_t *, uint32_t);
int HTTPServerReply_body_content_get(struct HTTPServerReply *, uint8_t * *, uint32_t *);
/* --- HTTPServerReply done --- */

/* Tag definition for DNSRequest */
enum dnsrequest_ {
  DNSREQUEST_TV_SEC=1,
  DNSREQUEST_TV_USEC=2,
  DNSREQUEST_REMOTE_ADDR=3,
  DNSREQUEST_PAYLOAD=4,
  DNSREQUEST_CHAOS_PAYLOAD=5,
  DNSREQUEST_CHAOS_REPLY=6,
  DNSREQUEST_CHAOS_SENT=7,
  DNSREQUEST_FPDNS_IQUERY=8,
  DNSREQUEST_FPDNS_TC=9,
  DNSREQUEST_FPHTTP_SERVER=10,
  DNSREQUEST_FPHTTP_DATE=11,
  DNSREQUEST_FPHTTP_POWERED=12,
  DNSREQUEST_FPHTTP_BODY_LEN=13,
  DNSREQUEST_HTTP_BODY_PAYLOAD=14,
  DNSREQUEST_SERVER_REPLY=15,
  DNSREQUEST_MAX_TAGS
};

/* Structure declaration for DNSRequest */
struct DNSRequest_access_ {
  int (*tv_sec_assign)(struct DNSRequest *, const uint32_t);
  int (*tv_sec_get)(struct DNSRequest *, uint32_t *);
  int (*tv_usec_assign)(struct DNSRequest *, const uint32_t);
  int (*tv_usec_get)(struct DNSRequest *, uint32_t *);
  int (*remote_addr_assign)(struct DNSRequest *, const uint8_t *, uint32_t);
  int (*remote_addr_get)(struct DNSRequest *, uint8_t * *, uint32_t *);
  int (*payload_assign)(struct DNSRequest *, const uint8_t *, uint32_t);
  int (*payload_get)(struct DNSRequest *, uint8_t * *, uint32_t *);
  int (*chaos_payload_assign)(struct DNSRequest *, const uint8_t *, uint32_t);
  int (*chaos_payload_get)(struct DNSRequest *, uint8_t * *, uint32_t *);
  int (*chaos_reply_assign)(struct DNSRequest *, const char *);
  int (*chaos_reply_get)(struct DNSRequest *, char * *);
  int (*chaos_sent_assign)(struct DNSRequest *, const uint32_t);
  int (*chaos_sent_get)(struct DNSRequest *, uint32_t *);
  int (*fpdns_iquery_assign)(struct DNSRequest *, const char *);
  int (*fpdns_iquery_get)(struct DNSRequest *, char * *);
  int (*fpdns_tc_assign)(struct DNSRequest *, const char *);
  int (*fpdns_tc_get)(struct DNSRequest *, char * *);
  int (*fphttp_server_assign)(struct DNSRequest *, const char *);
  int (*fphttp_server_get)(struct DNSRequest *, char * *);
  int (*fphttp_date_assign)(struct DNSRequest *, const char *);
  int (*fphttp_date_get)(struct DNSRequest *, char * *);
  int (*fphttp_powered_assign)(struct DNSRequest *, const char *);
  int (*fphttp_powered_get)(struct DNSRequest *, char * *);
  int (*fphttp_body_len_assign)(struct DNSRequest *, const uint32_t);
  int (*fphttp_body_len_get)(struct DNSRequest *, uint32_t *);
  int (*http_body_payload_assign)(struct DNSRequest *, const uint8_t *, uint32_t);
  int (*http_body_payload_get)(struct DNSRequest *, uint8_t * *, uint32_t *);
  int (*server_reply_assign)(struct DNSRequest *, const struct HTTPServerReply*);
  int (*server_reply_get)(struct DNSRequest *, struct HTTPServerReply* *);
};

struct DNSRequest {
  struct DNSRequest_access_ *base;

  uint32_t tv_sec_data;
  uint32_t tv_usec_data;
  uint8_t *remote_addr_data;
  uint32_t remote_addr_length;
  uint8_t *payload_data;
  uint32_t payload_length;
  uint8_t *chaos_payload_data;
  uint32_t chaos_payload_length;
  char *chaos_reply_data;
  uint32_t chaos_sent_data;
  char *fpdns_iquery_data;
  char *fpdns_tc_data;
  char *fphttp_server_data;
  char *fphttp_date_data;
  char *fphttp_powered_data;
  uint32_t fphttp_body_len_data;
  uint8_t *http_body_payload_data;
  uint32_t http_body_payload_length;
  struct HTTPServerReply* server_reply_data;

  uint8_t tv_sec_set;
  uint8_t tv_usec_set;
  uint8_t remote_addr_set;
  uint8_t payload_set;
  uint8_t chaos_payload_set;
  uint8_t chaos_reply_set;
  uint8_t chaos_sent_set;
  uint8_t fpdns_iquery_set;
  uint8_t fpdns_tc_set;
  uint8_t fphttp_server_set;
  uint8_t fphttp_date_set;
  uint8_t fphttp_powered_set;
  uint8_t fphttp_body_len_set;
  uint8_t http_body_payload_set;
  uint8_t server_reply_set;
};

struct DNSRequest *DNSRequest_new(void);
void DNSRequest_free(struct DNSRequest *);
void DNSRequest_clear(struct DNSRequest *);
void DNSRequest_marshal(struct evbuffer *, const struct DNSRequest *);
int DNSRequest_unmarshal(struct DNSRequest *, struct evbuffer *);
int DNSRequest_complete(struct DNSRequest *);
void evtag_marshal_DNSRequest(struct evbuffer *, uint32_t, 
    const struct DNSRequest *);
int evtag_unmarshal_DNSRequest(struct evbuffer *, uint32_t,
    struct DNSRequest *);
int DNSRequest_tv_sec_assign(struct DNSRequest *, const uint32_t);
int DNSRequest_tv_sec_get(struct DNSRequest *, uint32_t *);
int DNSRequest_tv_usec_assign(struct DNSRequest *, const uint32_t);
int DNSRequest_tv_usec_get(struct DNSRequest *, uint32_t *);
int DNSRequest_remote_addr_assign(struct DNSRequest *, const uint8_t *, uint32_t);
int DNSRequest_remote_addr_get(struct DNSRequest *, uint8_t * *, uint32_t *);
int DNSRequest_payload_assign(struct DNSRequest *, const uint8_t *, uint32_t);
int DNSRequest_payload_get(struct DNSRequest *, uint8_t * *, uint32_t *);
int DNSRequest_chaos_payload_assign(struct DNSRequest *, const uint8_t *, uint32_t);
int DNSRequest_chaos_payload_get(struct DNSRequest *, uint8_t * *, uint32_t *);
int DNSRequest_chaos_reply_assign(struct DNSRequest *, const char *);
int DNSRequest_chaos_reply_get(struct DNSRequest *, char * *);
int DNSRequest_chaos_sent_assign(struct DNSRequest *, const uint32_t);
int DNSRequest_chaos_sent_get(struct DNSRequest *, uint32_t *);
int DNSRequest_fpdns_iquery_assign(struct DNSRequest *, const char *);
int DNSRequest_fpdns_iquery_get(struct DNSRequest *, char * *);
int DNSRequest_fpdns_tc_assign(struct DNSRequest *, const char *);
int DNSRequest_fpdns_tc_get(struct DNSRequest *, char * *);
int DNSRequest_fphttp_server_assign(struct DNSRequest *, const char *);
int DNSRequest_fphttp_server_get(struct DNSRequest *, char * *);
int DNSRequest_fphttp_date_assign(struct DNSRequest *, const char *);
int DNSRequest_fphttp_date_get(struct DNSRequest *, char * *);
int DNSRequest_fphttp_powered_assign(struct DNSRequest *, const char *);
int DNSRequest_fphttp_powered_get(struct DNSRequest *, char * *);
int DNSRequest_fphttp_body_len_assign(struct DNSRequest *, const uint32_t);
int DNSRequest_fphttp_body_len_get(struct DNSRequest *, uint32_t *);
int DNSRequest_http_body_payload_assign(struct DNSRequest *, const uint8_t *, uint32_t);
int DNSRequest_http_body_payload_get(struct DNSRequest *, uint8_t * *, uint32_t *);
int DNSRequest_server_reply_assign(struct DNSRequest *, const struct HTTPServerReply*);
int DNSRequest_server_reply_get(struct DNSRequest *, struct HTTPServerReply* *);
/* --- DNSRequest done --- */

/* Tag definition for DNSResponder */
enum dnsresponder_ {
  DNSRESPONDER_TV_SEC=1,
  DNSRESPONDER_TV_USEC=2,
  DNSRESPONDER_REMOTE_ADDR=4,
  DNSRESPONDER_QUERY=5,
  DNSRESPONDER_MAX_TAGS
};

/* Structure declaration for DNSResponder */
struct DNSResponder_access_ {
  int (*tv_sec_assign)(struct DNSResponder *, const uint32_t);
  int (*tv_sec_get)(struct DNSResponder *, uint32_t *);
  int (*tv_usec_assign)(struct DNSResponder *, const uint32_t);
  int (*tv_usec_get)(struct DNSResponder *, uint32_t *);
  int (*remote_addr_assign)(struct DNSResponder *, const uint8_t *, uint32_t);
  int (*remote_addr_get)(struct DNSResponder *, uint8_t * *, uint32_t *);
  int (*query_assign)(struct DNSResponder *, const char *);
  int (*query_get)(struct DNSResponder *, char * *);
};

struct DNSResponder {
  struct DNSResponder_access_ *base;

  uint32_t tv_sec_data;
  uint32_t tv_usec_data;
  uint8_t *remote_addr_data;
  uint32_t remote_addr_length;
  char *query_data;

  uint8_t tv_sec_set;
  uint8_t tv_usec_set;
  uint8_t remote_addr_set;
  uint8_t query_set;
};

struct DNSResponder *DNSResponder_new(void);
void DNSResponder_free(struct DNSResponder *);
void DNSResponder_clear(struct DNSResponder *);
void DNSResponder_marshal(struct evbuffer *, const struct DNSResponder *);
int DNSResponder_unmarshal(struct DNSResponder *, struct evbuffer *);
int DNSResponder_complete(struct DNSResponder *);
void evtag_marshal_DNSResponder(struct evbuffer *, uint32_t, 
    const struct DNSResponder *);
int evtag_unmarshal_DNSResponder(struct evbuffer *, uint32_t,
    struct DNSResponder *);
int DNSResponder_tv_sec_assign(struct DNSResponder *, const uint32_t);
int DNSResponder_tv_sec_get(struct DNSResponder *, uint32_t *);
int DNSResponder_tv_usec_assign(struct DNSResponder *, const uint32_t);
int DNSResponder_tv_usec_get(struct DNSResponder *, uint32_t *);
int DNSResponder_remote_addr_assign(struct DNSResponder *, const uint8_t *, uint32_t);
int DNSResponder_remote_addr_get(struct DNSResponder *, uint8_t * *, uint32_t *);
int DNSResponder_query_assign(struct DNSResponder *, const char *);
int DNSResponder_query_get(struct DNSResponder *, char * *);
/* --- DNSResponder done --- */

/* Tag definition for StateGenerate */
enum stategenerate_ {
  STATEGENERATE_ADDR=1,
  STATEGENERATE_LAST_COUNT=3,
  STATEGENERATE_MAX_TAGS
};

/* Structure declaration for StateGenerate */
struct StateGenerate_access_ {
  int (*addr_assign)(struct StateGenerate *, const uint8_t *, uint32_t);
  int (*addr_get)(struct StateGenerate *, uint8_t * *, uint32_t *);
  int (*last_count_assign)(struct StateGenerate *, const uint32_t);
  int (*last_count_get)(struct StateGenerate *, uint32_t *);
};

struct StateGenerate {
  struct StateGenerate_access_ *base;

  uint8_t *addr_data;
  uint32_t addr_length;
  uint32_t last_count_data;

  uint8_t addr_set;
  uint8_t last_count_set;
};

struct StateGenerate *StateGenerate_new(void);
void StateGenerate_free(struct StateGenerate *);
void StateGenerate_clear(struct StateGenerate *);
void StateGenerate_marshal(struct evbuffer *, const struct StateGenerate *);
int StateGenerate_unmarshal(struct StateGenerate *, struct evbuffer *);
int StateGenerate_complete(struct StateGenerate *);
void evtag_marshal_StateGenerate(struct evbuffer *, uint32_t, 
    const struct StateGenerate *);
int evtag_unmarshal_StateGenerate(struct evbuffer *, uint32_t,
    struct StateGenerate *);
int StateGenerate_addr_assign(struct StateGenerate *, const uint8_t *, uint32_t);
int StateGenerate_addr_get(struct StateGenerate *, uint8_t * *, uint32_t *);
int StateGenerate_last_count_assign(struct StateGenerate *, const uint32_t);
int StateGenerate_last_count_get(struct StateGenerate *, uint32_t *);
/* --- StateGenerate done --- */

/* Tag definition for Address */
enum address_ {
  ADDRESS_ADDR=1,
  ADDRESS_MAX_TAGS
};

/* Structure declaration for Address */
struct Address_access_ {
  int (*addr_assign)(struct Address *, const uint8_t *, uint32_t);
  int (*addr_get)(struct Address *, uint8_t * *, uint32_t *);
};

struct Address {
  struct Address_access_ *base;

  uint8_t *addr_data;
  uint32_t addr_length;

  uint8_t addr_set;
};

struct Address *Address_new(void);
void Address_free(struct Address *);
void Address_clear(struct Address *);
void Address_marshal(struct evbuffer *, const struct Address *);
int Address_unmarshal(struct Address *, struct evbuffer *);
int Address_complete(struct Address *);
void evtag_marshal_Address(struct evbuffer *, uint32_t, 
    const struct Address *);
int evtag_unmarshal_Address(struct evbuffer *, uint32_t,
    struct Address *);
int Address_addr_assign(struct Address *, const uint8_t *, uint32_t);
int Address_addr_get(struct Address *, uint8_t * *, uint32_t *);
/* --- Address done --- */

/* Tag definition for State */
enum state_ {
  STATE_COUNT=4,
  STATE_GENERATORS=1,
  STATE_ADDRESSES=2,
  STATE_RNDSBOX=3,
  STATE_MAX_TAGS
};

/* Structure declaration for State */
struct State_access_ {
  int (*count_assign)(struct State *, const uint32_t);
  int (*count_get)(struct State *, uint32_t *);
  int (*generators_assign)(struct State *, int, const struct StateGenerate*);
  int (*generators_get)(struct State *, int, struct StateGenerate* *);
  struct StateGenerate*  (*generators_add)(struct State *msg);
  int (*addresses_assign)(struct State *, int, const struct Address*);
  int (*addresses_get)(struct State *, int, struct Address* *);
  struct Address*  (*addresses_add)(struct State *msg);
  int (*rndsbox_assign)(struct State *, const uint8_t *, uint32_t);
  int (*rndsbox_get)(struct State *, uint8_t * *, uint32_t *);
};

struct State {
  struct State_access_ *base;

  uint32_t count_data;
  struct StateGenerate* *generators_data;
  int generators_length;
  int generators_num_allocated;
  struct Address* *addresses_data;
  int addresses_length;
  int addresses_num_allocated;
  uint8_t *rndsbox_data;
  uint32_t rndsbox_length;

  uint8_t count_set;
  uint8_t generators_set;
  uint8_t addresses_set;
  uint8_t rndsbox_set;
};

struct State *State_new(void);
void State_free(struct State *);
void State_clear(struct State *);
void State_marshal(struct evbuffer *, const struct State *);
int State_unmarshal(struct State *, struct evbuffer *);
int State_complete(struct State *);
void evtag_marshal_State(struct evbuffer *, uint32_t, 
    const struct State *);
int evtag_unmarshal_State(struct evbuffer *, uint32_t,
    struct State *);
int State_count_assign(struct State *, const uint32_t);
int State_count_get(struct State *, uint32_t *);
int State_generators_assign(struct State *, int, const struct StateGenerate*);
int State_generators_get(struct State *, int, struct StateGenerate* *);
struct StateGenerate*  State_generators_add(struct State *msg);
int State_addresses_assign(struct State *, int, const struct Address*);
int State_addresses_get(struct State *, int, struct Address* *);
struct Address*  State_addresses_add(struct State *msg);
int State_rndsbox_assign(struct State *, const uint8_t *, uint32_t);
int State_rndsbox_get(struct State *, uint8_t * *, uint32_t *);
/* --- State done --- */

#endif  /* _DNSDATA_RPC_ */
